﻿using System;
using System.Collections.Generic;
using System.Text;

namespace StuderInterface.Helpers
{
    public static class ExceptionHelper
    {
        /// <summary>
        /// return all exception.Message including InnerException Messages.
        /// Each message is delimited by new-line ("\n") character.
        /// </summary>
        /// <param name="ex"></param>
        /// <returns></returns>
        public static string GetExceptionMessages(Exception ex)
        {
            var exp = ex; String errMsg = String.Empty;
            while (exp != null)
            {
                if (String.IsNullOrEmpty(errMsg))
                    errMsg = exp.Message;
                else
                    errMsg += "\n" + exp.Message;

                exp = exp.InnerException;
            }
            return errMsg;
        }
    }
}
