﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace StuderInterface.HttpClient
{
    /// <summary>
    /// data for whole unit, for example BSP, XTM, ...
    /// </summary>
    public class UnitData
    {
        List<ObjectData> data = new List<ObjectData>();
        public UnitData()
        {

        }
        public UnitData(UInt32 addr)
        {
            Addr = addr;
            
        }
        public UInt32 Addr { get; set; }
        public List<ObjectData> Data { get { return data; } }
        /// <summary>
        /// when objectId already exists overwrites value
        /// </summary>
        /// <param name="ObjectId"></param>
        /// <param name="value"></param>
        public void AddData(UInt32 objectId, object value)
        {
            var di = Data.FirstOrDefault(a => a.ObjectId == objectId);
            if (di == null)
            {
                Data.Add(new ObjectData(objectId, value));
            }
            else
                di.Value = value;
        }
    }

    public class ObjectData
    {
        public ObjectData()
        {

        }
        public ObjectData(UInt32 objectId, object value)
        {
            ObjectId = objectId;
            Value = value;
        }
        public UInt32 ObjectId { get; set; }
        public object Value { get; set; }
    }
}
