﻿using StuderEmulator.Studer;
using System;
using System.Collections.Generic;
using System.Text;

namespace StuderInterface.Settings
{
    public class ReqItem
    {
        public ReqItem()
        {

        }
        /// <summary>
        /// with copy of values
        /// </summary>
        /// <param name="reqItem"></param>
        public ReqItem(ReqItem reqItem)
        {
            Addr = reqItem.Addr;
            ObjType = reqItem.ObjType;
            ObjectId = reqItem.ObjectId;
            PropertyId = reqItem.PropertyId;
            Format = reqItem.Format;
            Priority = reqItem.Priority;
        }

        public int Addr { get; set; }
        public int ObjType { get; set; }
        public int ObjectId { get; set; }
        public int PropertyId { get; set; }

        public string Format { get; set; }

        public int Priority { get; set; }
        /// <summary>
        /// F - FLOAT (default)
        /// 
        /// </summary>
        /// <param name="reqItem"></param>
        /// <returns></returns>
        public static FormatEnum GetStuderFormat(ReqItem reqItem)
        {
            string format = reqItem?.Format;
            FormatEnum result = FormatEnum.SCOM_FORMAT_FLOAT;

            if (!string.IsNullOrEmpty(format))
            {
                switch (format.ToUpper())
                {
                    case "B":
                        result = FormatEnum.SCOM_FORMAT_BOOL;
                        break;
                    case "SE":
                        result = FormatEnum.SCOM_FORMAT_SHORT_ENUM;
                        break;
                    case "I":
                        result = FormatEnum.SCOM_FORMAT_INT32;
                        break;
                    case "F":
                        result = FormatEnum.SCOM_FORMAT_FLOAT;
                        break;
                    case "LE":
                        result = FormatEnum.SCOM_FORMAT_LONG_ENUM;
                        break;
                    case "S":
                        result = FormatEnum.SCOM_FORMAT_STRING;
                        break;
                    case "BS":
                        result = FormatEnum.SCOM_FORMAT_BYTE_STREAM;
                        break;
                    default:
                        result = FormatEnum.SCOM_FORMAT_FLOAT;
                        break;
                }
            }

            return result;
        }
    }
}
