﻿using StuderEmulator.Studer;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace StuderInterface.Settings
{
    public class SISettings
    {
        public string PortName { get; set; }
        /// <summary>
        /// url to use web - post to send JSON data to
        /// </summary>
        public string WebUrl { get; set; }
        /// <summary>
        /// when true write receved data to console window
        /// </summary>
        public bool WriteDataToConsole { get; set; }

        /// <summary>
        /// when processed data to log file
        /// </summary>
        public bool Debug { get; set; }
        public ReqItem[] Parameters { get; set; }
        /// <summary>
        /// returns format of data received from studer
        /// </summary>
        /// <param name="addr"></param>
        /// <param name="objType"></param>
        /// <param name="objId"></param>
        /// <returns></returns>
        public FormatEnum GetStuderFormat(UInt32 addr, UInt16 objType, UInt32 objId)
        {
            var par = Parameters.FirstOrDefault(a => a.Addr == addr && a.ObjType == objType && a.ObjectId == objId);
            if (par != null)
                return ReqItem.GetStuderFormat(par);

            return FormatEnum.SCOM_FORMAT_INVALID_FORMAT;
        }
    }
}
